const
  { pohyb smry sever (0), vchod (1), jih (2) a zpad (4) }
  dx : array [0..3] of longint = (0, 1, 0, -1);
  dy : array [0..3] of longint = (-1, 0, 1, 0);
  { omezen vstupu }
  MaxS = 500;
  MaxD = 500;
  MaxL = 500;

var
  Seq : array [1..MaxL] of char;  { sekvence pkaz }
  L : longint;                    { poet pkaz }
  Mapa : array [1..MaxS, 1..MaxD] of boolean; { mapa }
  S, D : longint;                 { rozmry plnu }
  Uteku : longint;                { poet polcek z nich robt unikne }
  Kroku : array [1..MaxS, 1..MaxD, 0..3] of longint;
  { 0 => neznmo, -1 => vede do smyky nebo zkoumno aktuln prochzkou }
  { >0 => poet tah k niku }

  { zsobnk stav pro prochzku }
  ZasX, ZasY : array [1..MaxS * MaxD * 4] of longint;
  ZasSmer : array [1..MaxS * MaxD * 4] of longint;
  ZasVel : longint;               { aktuln velikost }   

{ simuluj jeden pkaz ze zadanho stavu }
procedure Prikaz(var X, Y, P, Smer : longint);
var NX, NY : longint;
begin
  NX := X;
  NY := Y;
  case Seq[P] of
     'L' : Smer := (Smer + 3) mod 4;
     'R' : Smer := (Smer + 1) mod 4;
     '+' : begin NX := NX + dx[Smer]; NY := NY + dy[Smer]; end;
     '-' : begin NX := NX - dx[Smer]; NY := NY - dy[Smer]; end;
  end;
  if (NX < 1) or (NY < 1) or (NX > S) or (NY > D) or Mapa[NX, NY] then
  begin
    X := NX;
    Y := NY;
  end;
  P := (P mod L) + 1;
end;

procedure KolikKroku(X0, Y0 : longint);
var
  i, X, Y, P, Smer, k: longint;
begin
  ZasVel := 0;
  k := 0; { pkaz do cle } 
  P := 1; { pozice v programu }
  X := X0; Y := Y0; Smer := 0; { X0, Y0, sever }
  { dokud nedojdeme do cle a prozkoumvme nov stavy }
  while (k = 0) and (Kroku[X, Y, Smer] = 0) do
  begin
    Kroku [X, Y, Smer] := -1; { navtven stav }
    inc(ZasVel); { uloit na zsobnk }
    ZasX[ZasVel] := X;
    ZasY[ZasVel] := Y;
    ZasSmer[ZasVel] := Smer;
    { provst nanejv L krok }
    for i := 1 to L do
    begin
      Prikaz(X, Y, P, Smer);
      if (X < 1) or (Y < 1) or (X > S) or (Y > D) then 
      begin
        k := i; { po k krocch v cli }
	break;
      end;
    end;
  end;
  { doli jsme po L krocch na znmou hodnotu? }
  if (k = 0) and (Kroku [X, Y, Smer] > 0) then
    k := Kroku [X, Y, Smer] + L;
  { pokud jsme doli do smyky, meme nechat Kroku[X, Y, Smer] = -1 }
  { pro vechny vybran stavy prochzky }
  if k = 0 then exit;
  { pokud dojdeme na znmou hodnotu nebo do cle, vybereme zsobnk }
  while ZasVel > 0 do
  begin
    Kroku [ZasX[ZasVel], ZasY[ZasVel], ZasSmer[ZasVel]] := k;
    k := k + L;
    dec(ZasVel);
  end;
end;

var 
  i, j : longint; 
  z : char;
  f : text;

begin
  { naten vstupu }
  assign(f, 'akce.in');
  reset(f);
  readln(f, L);
  for i := 1 to L do
  begin
    read(f, z);
    Seq[i] := z;
  end;
  readln(f, S, D);
  for j := 1 to D do
  begin
    for i := 1 to S do
    begin
      read(f, z);
      Mapa[i, j] := (z = '.');
    end;
    readln(f);
  end;
  close(f);

  { prozkoumme vechna polka }
  Uteku := 0;
  for i := 1 to S do
    for j := 1 to D do
    begin
      if Mapa[i, j] and (Kroku[i, j, 0] = 0) then 
	KolikKroku(i, j);
      if Kroku[i, j, 0] > 0 then 
	inc(Uteku);
    end;

  { vstup }
  assign(f, 'akce.out');
  rewrite(f);
  writeln(f, Uteku);
  for j := 1 to D do
  begin
    for i := 1 to S do
    begin
      if i > 1 then write(f, ' ');
      if Kroku[i, j, 0] > 0 then
        write(f, Kroku[i, j, 0])
      else
        write(f, 0);
    end;
    writeln(f);
  end;
  close(f);
end.

