program roboti;

const
      //pohyb smery sever, zapad, jih, vychod
      dx:array[0..3] of integer = (0, -1, 0, 1);
      dy:array[0..3] of integer = (-1, 0, 1, 0);

      MaxW = 500;
      MaxH = 500;
      MaxSeq = 500;

      MapExit = -1;

var
    {vstup}
    orders : array[1..MaxSeq] of char; {sekvence prikazu}
    orderslen : Integer; {pocet prikazu}
    map : array[1..MaxW, 1..MaxH] of boolean; {mapa}

    {graf dany planem a sekvenci prikazu pro robota}
    toX, toY : array[1..MaxW, 1..MaxH, 0..3] of integer; {cilovy vrchol hrany}
    toDir : array[1..MaxW, 1..MaxH, 0..3] of byte; {cilova orientace po pruchodu}
    moves : array[1..MaxW, 1..MaxH, 0..3] of longint; {cena hrany}

    {seznam opacne orientovanych hran}
    fromC : array[1..MaxW, 1..MaxH, 0..3] of longint; {stupen vrcholu}
    fromX, fromY : array[1..MaxW * MaxH * 4] of integer; {pocatecni vrchol hrany}
    fromDir : array[1..MaxW * MaxH * 4] of byte; {pocatecni smer robota}
    fromLast : longint; {posledni index hrany}

    w, h : integer;    {rozmery planu}

    {fronta vrcholu pro zpracovani}
    qX, qY : array[0..MaxW * MaxH * 4] of integer; {souradnice policka ve fronte}
    qdir : array[0..MaxW * MaxH * 4] of byte; {smer robota ve fronte} 
    qpos, qcnt : longint; {pozice ve fronte, pocet prvku ve fronte}

    {priznak ze z policka se opousti plan - uvazujeme pouze pro smer sever}
    exiting : array[1..MaxW, 1..MaxH] of boolean;
    exitingCount : longint; {pocet vystupnich policek}

    {pomocne promenne}
    i, j, k : integer;
    edgeIndex : longint;
    z: char;
    last: longint;



function PositionOk(x, y : integer): boolean;
begin
  if (x > 0) and (y > 0) and (x <= w) and (y <= h) then
   PositionOk := map[x, y] else
   PositionOk := true;
end;

procedure SimMoves(stX, stY, stDir : integer);
var x, y, dir : integer;
    k : integer;
begin
  x := stX;
  y := stY;
  dir := stDir;
  for k := 1 to orderslen do
  begin
    case orders[k] of
    'L' : dir := (dir + 1)  mod 4;
    'R' : if dir = 0 then dir := 3
                     else dir := (dir - 1);
    '+' : if PositionOk(x + dx[dir], y + dy[dir]) then
           begin
             x := x + dx[dir];
             y := y + dy[dir];
           end;
    '-' : if PositionOk(x - dx[dir], y - dy[dir]) then
           begin
             x := x - dx[dir];
             y := y - dy[dir];
           end;
    end;
    if (x < 1) or (y < 1) or (x > w) or (y > h) then
     begin
       moves[stX, stY, stDir] := k;
       toX[stX, stY, stDir] := MapExit;
       toY[stX, stY, stDir] := MapExit;
       exit;
     end;
  end;
  moves[stX, stY, stDir] := orderslen;
  toX[stX, stY, stDir] := x;
  toY[stX, stY, stDir] := y;
  toDir[stX, stY, stDir] := dir;
end;

procedure ProcessQueue;
var px, py,pdir : Integer;
    edgeFirst, edgeLast, e : longint;
    nx, ny, nk : Integer;
begin
  qpos := 0;
  while qpos < qcnt do
  begin
    px := qx[qpos];
    py := qy[qpos];
    pdir := qdir[qpos];
    inc(qpos);
    if pdir = 0 then { 0 = sever }
      exiting[px, py] := true;
    edgeFirst := fromC[px, py, pdir] + 1; {posledni hrana predchoziho + 1}
    edgeLast := fromLast;
    if (px < w) or (py < h) or (pdir < 3) then
    begin
       nx := px + 1; ny := py; nk := pdir;
       if nx > w then begin inc(ny); nx := 1; end;
       if ny > h then begin inc(nk); ny := 1; end;
       edgeLast := fromC[nx, ny, nk]; {posledni hrana tohoto policka}
    end;

    for e := edgeFirst to edgeLast do
    begin
      qx[qcnt] := fromX[e];
      qy[qcnt] := fromY[e];
      qdir[qcnt] := fromDir[e];
      inc(moves[fromX[e], fromY[e], fromDir[e]], moves[px, py, pdir]);
      inc(qcnt);
    end;
  end;
end;

begin
  close(input);
  assign(input, 'akce.in');
  reset(input);

  {* Nacteni vstupu *}
  readln(orderslen);
  for i := 1 to orderslen do
    begin
      read(z);
      orders[i] := z;
    end;
  readln(w, h);
  for j := 1 to h do
   begin
     for i := 1 to w do
     begin
       read(z);
       map[i, j] := (z = '.');
     end;
     readln;
   end;

  {* Sestaveni hran jednoho vykonani cyklu *}
  for i := 1 to w do
   for j := 1 to h do
    if map[i, j] then {nezacal jsem v prekazce?}
     for k := 0 to 3 do
       SimMoves(i, j, k);

  {* Konstrukce opacne orientace grafu *}
  for i := 1 to w do
   for j := 1 to h do
    if map[i, j] then 
    for k := 0 to 3 do
      if (toX[i, j, k] <> MapExit) then
        inc(fromC[toX[i, j, k], toY[i, j, k], toDir[i, j, k]]);
        {napocitame z kolika policek do [i, j] dorazime}

  {vybudujeme seznam obracenych hran pro kazde policko}
  last := 0;
  for k := 0 to 3 do
   for j := 1 to h do
    for i := 1 to w do
     begin
       inc(fromC[i, j, k], last); {pocitame indexy v seznamu hran}
       last := fromC[i, j, k];
     end;
  fromLast := last - 1;

  {a ted podle indexu hrany ulozime}
  for i := 1 to w do
   for j := 1 to h do
    if map[i, j] then
    for k := 0 to 3 do
     if (toX[i, j, k] <> MapExit) then
     begin {ty ktere nevedou pryc ukladame do seznamu}
       edgeIndex := fromC[toX[i, j, k], toY[i, j, k], toDir[i, j, k]];
       dec(fromC[toX[i, j, k], toY[i, j, k], toDir[i, j, k]]);
       fromX[edgeIndex] := i;
       fromY[edgeIndex] := j;
       fromDir[edgeIndex] := k;
     end else
     begin {policka, z nichz jdeme mimo plan, pridame rovnou do fronty}
       qx[qcnt] := i;
       qy[qcnt] := j;
       qdir[qcnt] := k;
       inc(qcnt);
     end;

   ProcessQueue; {Zpracujeme frontu policek - projdeme plan do sirky}

   close(output);
   assign(output, 'akce.out');
   rewrite(output);

   {* Vystup *}
   exitingCount := 0;
   for i := 1 to w do
    for j := 1 to h do
     if exiting[i, j] then inc(exitingCount);
   Writeln(exitingCount);
   
   for j := 1 to h do
   begin
     for i := 1 to w do
     begin
       if i > 1 then write(' ');
       if exiting[i, j] then
         write(moves[i, j, 0 {sever}]) else write(0);
     end;
     writeln;
   end;

   close(output);
end.
